## mir 2.25.2

=== CMakeLists.txt ===
# Copyright © Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 or 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.16)

cmake_policy(SET CMP0015 NEW)
cmake_policy(SET CMP0022 NEW)

set(CMAKE_GCOV gcov)

project(
  Mir
  VERSION 2.25.2
  DESCRIPTION "Mir compositor library"
  LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

add_compile_definitions(MIR_VERSION_MAJOR=${PROJECT_VERSION_MAJOR})
add_compile_definitions(MIR_VERSION_MINOR=${PROJECT_VERSION_MINOR})
add_compile_definitions(MIR_VERSION_MICRO=${PROJECT_VERSION_PATCH})
add_compile_definitions(_GNU_SOURCE)
add_compile_definitions(_FILE_OFFSET_BITS=64)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
execute_process(
  COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
  OUTPUT_VARIABLE TARGET_ARCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Enable generation of compile_commands.json, for use by the clangd LSP
set(CMAKE_EXPORT_COMPILE_COMMANDS on)

option(use_debflags "Use build flags from dpkg-buildflags." OFF)
if(use_debflags)
  include (cmake/Debian.cmake)
endif()
include (CMakeDependentOption)
include (cmake/MirCommon.cmake)
include (GNUInstallDirs)

set(build_types "None;Debug;Release;RelWithDebInfo;MinSizeRel;AddressSanitizer;ThreadSanitizer;UBSanitizer")
# Change informational string for CMAKE_BUILD_TYPE
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "${build_types}" FORCE)
# Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")


set(MIR_FATAL_COMPILE_WARNINGS ON CACHE BOOL "Should compiler warnings fail the build")
if(MIR_FATAL_COMPILE_WARNINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  # Disable maybe-uninitialized errors on GCC when optimisation is enabled
  # They are notorious for false-positives
  # Also, disable array-bounds errors, they are likewise significantly
  # false-positivey
  # (We particularly hit https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111415)
  if ((CMAKE_C_COMPILER_ID MATCHES "GNU") AND NOT (CMAKE_BUILD_TYPE MATCHES "Debug"))
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=maybe-uninitialized -Wno-error=array-bounds")
  endif()
  if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") AND NOT (CMAKE_BUILD_TYPE MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized -Wno-error=array-bounds")
  endif()
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wmismatched-tags HAS_W_MISMATCHED_TAGS)

if(HAS_W_MISMATCHED_TAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-mismatched-tags")
endif()

# GCC 7.1 fixed a bug in the ARM ABI, which results in some std::vector methods
# (among others) generating this warning.
#
# There's nothing we can do about it; everything just needs to be rebuilt with
# GCC 7.1.
check_cxx_compiler_flag(-Wpsabi HAS_W_PSABI)
if(HAS_W_PSABI)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif()

set(MIR_USE_LD ld CACHE STRING "Linker to use")
set_property(CACHE MIR_USE_LD PROPERTY STRINGS "ld;gold;lld;mold")
if(MIR_USE_LD MATCHES "gold")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=gold")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
endif()
if(MIR_USE_LD MATCHES "lld")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=lld")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
endif()
if(MIR_USE_LD MATCHES "mold")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=mold")
  set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=mold")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=mold")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES "addresssanitizer")
  add_compile_options(-fsanitize=address -fno-omit-frame-pointer)
  add_link_options(-fsanitize=address)
elseif(cmake_build_type_lower MATCHES "threadsanitizer")
  add_compile_options(-fsanitize=thread -fno-omit-frame-pointer)
  add_link_options(-fsanitize=thread)
elseif(cmake_build_type_lower MATCHES "ubsanitizer")
  add_compile_options(-fsanitize=undefined -fno-omit-frame-pointer)
  add_link_options(-fsanitize=undefined)
  # "Symbol already defined" errors occur with pre-compiled headers
  SET(MIR_USE_PRECOMPILED_HEADERS OFF CACHE BOOL "Use precompiled headers" FORCE)
  # We have inline classes as interfaces used by .so's and implemented elsewhere.
  # This results in multiple trivial implementations. So let's not warn about that.
  add_compile_options(-fno-sanitize=vptr)
else()
  # AddressSanitizer builds fail if we disallow undefined symbols
  add_link_options(-Wl,--no-undefined)
endif()

enable_testing()
find_package(PkgConfig)

# Check for boost
find_package(Boost 1.48.0 COMPONENTS program_options iostreams REQUIRED)

add_compile_definitions(EGL_NO_X11)

pkg_check_modules(WAYLAND_EGLSTREAM wayland-eglstream IMPORTED_TARGET)

# Set the default platforms based on availability of NVIDIA libraries
if (WAYLAND_EGLSTREAM_FOUND)
  set(
    MIR_PLATFORM
    gbm-kms;atomic-kms;x11;eglstream-kms;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'atomic-kms', 'x11', 'eglstream-kms', or 'wayland')"
  )
else()
  set(
    MIR_PLATFORM
    gbm-kms;atomic-kms;x11;wayland
    CACHE
    STRING
    "a list of graphics backends to build (options are 'gbm-kms', 'atomic-kms', 'x11', 'eglstream-kms', or 'wayland')"
  )
endif()

list(GET MIR_PLATFORM 0 MIR_TEST_PLATFORM)

option(MIR_ENABLE_TESTS "Build tests" ON)
CMAKE_DEPENDENT_OPTION(
  MIR_ENABLE_WLCS_TESTS "Also Build WLCS tests" ON
  "MIR_ENABLE_TESTS" OFF
)
CMAKE_DEPENDENT_OPTION(
  MIR_RUN_WLCS_TESTS "Run WLCS tests as part of testsuite" ON
  "MIR_ENABLE_WLCS_TESTS" OFF
)
CMAKE_DEPENDENT_OPTION(
  MIR_SIGBUS_HANDLER_ENVIRONMENT_BROKEN "Expect WLCS BadBuffer tests to fail" OFF
  "MIR_RUN_WLCS_TESTS" OFF
)

CMAKE_DEPENDENT_OPTION(MIR_ENABLE_COVERAGE "Enable code coverage" OFF MIR_ENABLE_TESTS OFF)
if(MIR_ENABLE_COVERAGE)
    include(CodeCoverage)
    append_coverage_compiler_flags()
    setup_target_for_coverage_lcov(
        NAME coverage-html
        EXECUTABLE ctest --test-dir ${CMAKE_BINARY_DIR} --output-on-failure
        EXCLUDE "tests/*" "${CMAKE_BINARY_DIR}/*"
        LCOV_ARGS --ignore-errors inconsistent --ignore-errors mismatch
        GENHTML_ARGS --ignore-errors inconsistent --ignore-errors corrupt
    )

    setup_target_for_coverage_gcovr_xml(
        NAME coverage-xml
        EXECUTABLE ctest --test-dir ${CMAKE_BINARY_DIR} --output-on-failure
        EXCLUDE "tests/*" "${CMAKE_BINARY_DIR}/*"
    )

    add_custom_target(coverage
        DEPENDS coverage-html coverage-xml
    )
endif()

pkg_check_modules(APPARMOR IMPORTED_TARGET libapparmor)

CMAKE_DEPENDENT_OPTION(
  MIR_USE_APPARMOR "Whether or not Mir should build with support for AppArmor" ON
  "APPARMOR_FOUND" OFF
)
if (MIR_USE_APPARMOR)
  add_compile_definitions(MIR_USE_APPARMOR)
endif()

SET(MIR_EXCLUDE_TESTS "" CACHE STRING "Semicolon-separated list of tests to exclude (wildcards accepted)")


foreach(platform IN LISTS MIR_PLATFORM)
  if (platform STREQUAL "gbm-kms")
    set(MIR_BUILD_PLATFORM_GBM_KMS TRUE)
  endif()
  if (platform STREQUAL "atomic-kms")
    set(MIR_BUILD_PLATFORM_ATOMIC_KMS TRUE)
  endif()
  if (platform STREQUAL "x11")
     set(MIR_BUILD_PLATFORM_X11 TRUE)
  endif()
  if (platform STREQUAL "eglstream-kms")
     if (NOT WAYLAND_EGLSTREAM_FOUND)
        message(FATAL_ERROR "EGLStream platform requested, but required NVIDIA external EGL platform nvidia-egl-wayland not found")
     endif()
     set(MIR_BUILD_PLATFORM_EGLSTREAM_KMS TRUE)
  endif()
  if (platform STREQUAL "wayland")
     set(MIR_BUILD_PLATFORM_WAYLAND TRUE)
  endif()
endforeach(platform)

set(MIR_ENABLE_RUST OFF CACHE BOOL "Enable Rust support")
if (MIR_ENABLE_RUST)
  include(cmake/RustLibrary.cmake)
  add_compile_definitions(MIR_ENABLE_RUST)
endif()

pkg_check_modules(GLM glm)
if(NOT GLM_FOUND)
  find_package(glm REQUIRED)  # There's no glm.pc on Fedora, but find_package(glm) fails on Ubuntu...
endif()
pkg_check_modules(DRM REQUIRED IMPORTED_TARGET libdrm)
pkg_check_modules(EGL REQUIRED IMPORTED_TARGET egl)
pkg_check_modules(EPOXY REQUIRED IMPORTED_TARGET epoxy)
pkg_check_modules(FREETYPE freetype2 REQUIRED IMPORTED_TARGET)
pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-2.0 gio-unix-2.0)
pkg_check_modules(GLESv2 REQUIRED IMPORTED_TARGET glesv2)
pkg_check_modules(GLIB REQUIRED IMPORTED_TARGET glib-2.0)
pkg_check_modules(LIBINPUT REQUIRED IMPORTED_TARGET libinput>=1.1)
pkg_check_modules(LTTNG_UST REQUIRED IMPORTED_TARGET lttng-ust>=2.9)
pkg_check_modules(UDEV REQUIRED IMPORTED_TARGET libudev)
pkg_check_modules(UUID REQUIRED IMPORTED_TARGET uuid)
pkg_check_modules(WAYLAND_CLIENT REQUIRED IMPORTED_TARGET wayland-client)
pkg_check_modules(WAYLAND_SERVER REQUIRED IMPORTED_TARGET wayland-server)
pkg_check_modules(X11_XCURSOR REQUIRED IMPORTED_TARGET xcursor)
pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb)
pkg_check_modules(XCB_COMPOSITE REQUIRED IMPORTED_TARGET xcb-composite)
pkg_check_modules(XCB_RANDR REQUIRED IMPORTED_TARGET xcb-randr)
pkg_check_modules(XCB_RENDER REQUIRED IMPORTED_TARGET xcb-render)
pkg_check_modules(XCB_RES REQUIRED IMPORTED_TARGET xcb-res)
pkg_check_modules(XCB_XFIXES REQUIRED IMPORTED_TARGET xcb-xfixes)
pkg_check_modules(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)

include(CheckCXXSymbolExists)

# Add USDT hooks to all LTTNG tracepoints
#
# This might be gnarly; this tweaks an LTTNG header to enable its
# USDT integration. The integration only involves #include-ing a
# SystemTap header and calling a macro from it in the LTTNG macro,
# but there aren't guarantees this won't change in future.
include(CheckIncludeFile)
CHECK_INCLUDE_FILE(sys/sdt.h HAVE_SYS_SDT_H)
if (HAVE_SYS_SDT_H)
  add_compile_definitions(LTTNG_UST_HAVE_SDT_INTEGRATION)
endif()

if (MIR_BUILD_PLATFORM_GBM_KMS OR MIR_BUILD_PLATFORM_ATOMIC_KMS)
  pkg_check_modules(GBM REQUIRED IMPORTED_TARGET gbm>=11.0.0)
endif()

set(MIR_TRACEPOINT_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/mir/tools)

mir_make_pkgconfig_variable(PKGCONFIG_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
mir_make_pkgconfig_variable(PKGCONFIG_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}")
include(JoinPaths)

add_subdirectory(doc)
add_subdirectory(src/)

add_subdirectory(examples/)
add_subdirectory(cmake/)

if (MIR_ENABLE_TESTS)
  find_package(GtestGmock REQUIRED)
  pkg_check_modules(LIBEVDEV REQUIRED IMPORTED_TARGET libevdev)
  include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})
  add_subdirectory(tests/)
  add_subdirectory(examples/tests/)

=== doc/CMakeLists.txt ===
set(BUILDDIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx/_build)
set(MAKEOPTS
  BUILDDIR=${BUILDDIR}
  VENVDIR=${CMAKE_CURRENT_BINARY_DIR}/sphinx/venv
  DOCTREESDIR=${CMAKE_CURRENT_BINARY_DIR}/sphinx/.doctrees
)
set(SPHINXDIR ${CMAKE_CURRENT_SOURCE_DIR}/sphinx)

# Build a minimal Mir compositor to determine common options
include(MirCommon)
mir_add_wrapped_executable(demo-mir-compositor NOINSTALL
  sphinx/tutorial/first-wayland-compositor/main.cpp
)
target_link_libraries(demo-mir-compositor
  miral
)
set(OPTIONS_REFERENCE ${SPHINXDIR}/configuring/reference/options.md.include)
add_custom_target(
  COMMAND
    ${CMAKE_BINARY_DIR}/bin/demo-mir-compositor --help-markdown
    | sed "s@${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}@\\<LIBDIR\\>@g"
    > ${OPTIONS_REFERENCE}
  BYPRODUCTS ${OPTIONS_REFERENCE}
  DEPENDS demo-mir-compositor
)
# Verify the options reference is up to date
add_test(
  NAME verify-options-reference-unchanged
  COMMAND bash -c "diff --unified \
    ${OPTIONS_REFERENCE} \
    <(
      ${CMAKE_BINARY_DIR}/bin/demo-mir-compositor --help-markdown \
      | head -c -1 \
      | sed 's@${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}@\\<LIBDIR\\>@g' \
     )"
)

option(
  BUILD_DOXYGEN
  "Build Doxygen documentation as part of the default build"
  OFF
)

# Modifications to `MAKEOPTS` have to be made before targets are generated
# below.
if(BUILD_DOXYGEN)
  find_package(Doxygen 1.9.8 REQUIRED COMPONENTS dot)
  set(MAKEOPTS
    ${MAKEOPTS}
    MIR_BUILD_API_DOCS=1
    # FIXME: Sphinx gets itself into a bind reading cached API state
    EXTRA_SPHINXOPTS=-E
  )
endif()

set(SPHINX_TARGETS
  clean
  clean-doc
  html
  linkcheck
  lint-md
  pa11y
  run
  serve
  spelling
  vale
  woke
)

foreach(target IN LISTS SPHINX_TARGETS)
  add_custom_target(doc-${target}
    # In `VAR1=<value> make <target> VAR2=<value>, only `VAR1` is inherited by
    # `make`'s children, `VAR2` only applies within `make`.
    COMMAND ${CMAKE_COMMAND} -E env "MIR_BUILD_DIR=${CMAKE_BINARY_DIR}"
            make -C ${SPHINXDIR} ${target} ${MAKEOPTS}
    USES_TERMINAL
  )
endforeach()

add_custom_target(doc DEPENDS doc-html)
add_custom_target(
  doc-checks
  DEPENDS doc-linkcheck
          doc-lint-md
          doc-spelling
          doc-vale
          doc-woke
)

if(BUILD_DOXYGEN)
  set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen_output)

  add_custom_target(doxygen
    COMMAND
      ${CMAKE_COMMAND} -E env
      DOXYGEN_OUTPUT_DIR=${DOXYGEN_OUTPUT_DIR}
      doxygen
      ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    BYPRODUCTS ${DOXYGEN_OUTPUT_DIR}
  )

  add_custom_target(doxygen-clean
    COMMAND ${CMAKE_COMMAND} -E rm -rf ${DOXYGEN_OUTPUT_DIR}
    COMMAND git clean -xf ${SPHINXDIR}/api/*
  )

  add_dependencies(doc-html doxygen)
  add_dependencies(doc-run doxygen)
  add_dependencies(doc-clean doxygen-clean)
endif()

install(
  DIRECTORY ${BUILDDIR}
  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/mir-doc
  OPTIONAL
)

=== src/CMakeLists.txt ===
# We need MIRPLATFORM_ABI in both libmirplatform and the platform implementations.
set(MIRPLATFORM_ABI 34)

set(MIRAL_VERSION_MAJOR 5)
set(MIRAL_VERSION_MINOR 6)
set(MIRAL_VERSION_PATCH 0)
set(MIRAL_VERSION ${MIRAL_VERSION_MAJOR}.${MIRAL_VERSION_MINOR}.${MIRAL_VERSION_PATCH})

execute_process(
    COMMAND sh -c "head -n 1 ${PROJECT_SOURCE_DIR}/src/platform/symbols.map | cut -f 1 -d' ' | cut -f 3 -d_"
    OUTPUT_VARIABLE MIR_SERVER_GRAPHICS_PLATFORM_STANZA_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Add the core and platform implementations before exposing any private APIs
add_subdirectory(core)
add_subdirectory(platforms/)

# the src/include/... directories should be private to the implementation
add_subdirectory(common/)

add_subdirectory(platform/)
add_subdirectory(wayland/)
add_subdirectory(server/)
add_subdirectory(miral/)
add_subdirectory(miroil/)

add_executable(wrapper wrapper.c)
target_compile_definitions(wrapper PUBLIC
    EXECUTABLE_FORMAT=\"%s.bin\"
    _DEFAULT_SOURCE
    _BSD_SOURCE)

set(MIR_SERVER_REFERENCES ${MIR_SERVER_REFERENCES} PARENT_SCOPE)
set(MIR_SERVER_PLATFORM_PATH ${MIR_SERVER_PLATFORM_PATH} PARENT_SCOPE)

# We need the ABI versions in the tests
set(MIR_SERVER_GRAPHICS_PLATFORM_ABI ${MIR_SERVER_GRAPHICS_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_INPUT_PLATFORM_ABI ${MIR_SERVER_INPUT_PLATFORM_ABI} PARENT_SCOPE)
set(MIR_SERVER_GRAPHICS_PLATFORM_VERSION ${MIR_SERVER_GRAPHICS_PLATFORM_VERSION} PARENT_SCOPE)
set(MIR_INPUT_PLATFORM_VERSION_SCRIPT ${MIR_INPUT_PLATFORM_VERSION_SCRIPT} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
pkg_check_modules(UMOCKDEV REQUIRED IMPORTED_TARGET umockdev-1.0>=0.6)
if (NOT UMOCKDEV_FOUND)
  message(FATAL_ERROR "Umockdev not found, cannot build without disabling tests (via MIR_ENABLE_TESTS).")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wnull-dereference HAS_W_NULL_DEREFERENCE)
check_cxx_compiler_flag(-Woverloaded-virtual HAS_W_OVERLOADED_VIRTUAL)
check_cxx_compiler_flag(-Winconsistent-missing-override HAS_W_INCONSISTENT_MISSING_OVERRIDE)
check_cxx_compiler_flag(-Wgnu-zero-variadic-macro-arguments HAS_W_GNU_ZERO_VARIADIC_MACRO_ARGUMENTS)
check_cxx_compiler_flag(-Wno-sign-compare HAS_W_GNU_SIGN_COMPARE)
check_cxx_compiler_flag(-Wmaybe-uninitialized HAS_W_MAYBE_UNINITIALIZED)
check_cxx_compiler_flag(-Winfinite-recursion HAS_W_INFINITE_RECURSION)

if (HAS_W_NULL_DEREFERENCE)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=null-dereference")
endif()
if (HAS_W_OVERLOADED_VIRTUAL)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=overloaded-virtual")
endif()
if (HAS_W_INCONSISTENT_MISSING_OVERRIDE)
  # MOCK_METHOD()s cannot be marked as override; we cannot consistently mark overrides
  # in the tests.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
endif()
if (HAS_W_GNU_ZERO_VARIADIC_MACRO_ARGUMENTS)
  # INSTANTIATE_TEST_SUITE_P hits this like a slice of lemon wrapped around a large gold brick.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu-zero-variadic-macro-arguments")
else()
  # GCC is a bit less flexible than clang and needs a bigger hammer...
  if (NOT MIR_USE_PRECOMPILED_HEADERS)
    # Work around the Google Test headers not being C++11 friendly (LP: #1658604)
    string(REPLACE "-pedantic" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
  endif()
endif()
if (HAS_W_GNU_SIGN_COMPARE)
  # TODO fix the code
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
endif()
if (HAS_W_MAYBE_UNINITIALIZED)
  # Avoid g++ complaints about gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized")
endif()
if (HAS_W_INFINITE_RECURSION)
  # g++-12 doesn't notice that Abort() is going to call a [[noreturn]] function
  # before Invalid<T>() tries to return itself.
  add_compile_options(-Wno-error=infinite-recursion)
endif()

# we are shipping a static test archive for downstreams and don't want to ship
# LTO bytecode in there
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-lto")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")

include(CheckSymbolExists)
list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
string(REPLACE " -Werror " " " CMAKE_C_FLAGS ${CMAKE_C_FLAGS})    # This flag breaks check_symbol_exists()
check_symbol_exists(pthread_getname_np pthread.h HAVE_PTHREAD_GETNAME_NP)

list(APPEND CMAKE_REQUIRED_HEADERS ${GTEST_INCLUDE_DIRECTORIES})

if (MIR_BUILD_PLATFORM_GBM_KMS)
  add_compile_definitions(MIR_BUILD_PLATFORM_GBM_KMS)
endif()

# public headers (only public headers should be accessed by acceptance tests)
include_directories(
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${PROJECT_SOURCE_DIR}/include/test
)

option(MIR_BUILD_ACCEPTANCE_TESTS "Build acceptance tests" ON)
option(MIR_BUILD_INTEGRATION_TESTS "Build integration tests" ON)
option(MIR_BUILD_WINDOW_MANAGEMENT_TESTS "Build window management tests" ON)
option(MIR_BUILD_PERFORMANCE_TESTS "Build performance tests" ON)
option(MIR_BUILD_MIRAL_TESTS "Build miral tests" ON)
option(MIR_BUILD_UNIT_TESTS "Build unit tests" ON)
option(MIR_BUILD_PLATFORM_TEST_HARNESS "Build platform test harness" ON)

cmake_dependent_option(MIR_BUILD_INTERPROCESS_TESTS
  "Build interprocess acceptance tests as part of default testing" ON
  "MIR_BUILD_ACCEPTANCE_TESTS" OFF)


if (MIR_BUILD_ACCEPTANCE_TESTS)
  add_subdirectory(acceptance-tests/)
  add_subdirectory(umock-acceptance-tests/)
endif (MIR_BUILD_ACCEPTANCE_TESTS)

if (MIR_BUILD_PERFORMANCE_TESTS)
    add_subdirectory(performance-tests/)
endif(MIR_BUILD_PERFORMANCE_TESTS)

if (MIR_BUILD_MIRAL_TESTS)
  add_subdirectory(miral)
endif(MIR_BUILD_MIRAL_TESTS)

# Private test headers used by integration and unit tests
include_directories(
  include
)

if (MIR_BUILD_INTEGRATION_TESTS)
  add_subdirectory(integration-tests/)
endif (MIR_BUILD_INTEGRATION_TESTS)

if (MIR_BUILD_WINDOW_MANAGEMENT_TESTS)
  add_subdirectory(window_management_tests/)
endif(MIR_BUILD_WINDOW_MANAGEMENT_TESTS)

if (MIR_BUILD_UNIT_TESTS)
  add_subdirectory(unit-tests/)
endif (MIR_BUILD_UNIT_TESTS)

if (MIR_BUILD_PLATFORM_TEST_HARNESS)
  add_subdirectory(platform_test_harness/)
endif (MIR_BUILD_PLATFORM_TEST_HARNESS)

add_subdirectory(mir_test/)
add_subdirectory(mir_test_framework/)
add_subdirectory(mir_test_doubles/)

add_library(mir-test-assist STATIC)

add_library(mir-test-assist-internal STATIC)

target_link_libraries(mir-test-assist
PUBLIC
  miral
  mirserver
  mir-public-test
  mir-public-test-doubles
  mir-public-test-framework

  ${GTEST_BOTH_LIBRARIES}
PRIVATE
  ${GMOCK_MAIN_LIBRARY}
  ${GMOCK_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
)

target_link_libraries(mir-test-assist-internal
PUBLIC
  mirserver
  mir-protected-test-framework
  mir-protected-test-doubles

  ${GTEST_BOTH_LIBRARIES}
PRIVATE
  ${GMOCK_MAIN_LIBRARY}
  ${GMOCK_LIBRARIES}
)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirtest.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirtest.pc
  @ONLY
)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirtest-internal.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirtest-internal.pc
  @ONLY
)

install(TARGETS mir-test-assist
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(TARGETS mir-test-assist-internal
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/test/mir
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mirtest"
)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/test/mir_test_framework
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mirtest"
)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/test/miral
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mirtest"
)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/tests/include/mir
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mirtest-internal"
)
install(DIRECTORY ${CMAKE_SOURCE_DIR}/tests/include/mir_test_framework
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mirtest-internal"
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mirtest.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mirtest-internal.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

mir_add_memcheck_test()
mir_add_detect_fd_leaks_test()

=== doc/sphinx/Makefile ===
# Minimal makefile for Sphinx documentation
#
# Add your customisation to `Makefile` instead.

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXDIR       = .sphinx
DOCTREESDIR     ?= $(SPHINXDIR)/.doctrees
SPHINXOPTS      ?= -c . -d $(DOCTREESDIR) -j auto $(EXTRA_SPHINXOPTS)
SPHINXBUILD     ?= $(VENVDIR)/bin/sphinx-build
SOURCEDIR       = .
BUILDDIR        = _build
VENVDIR         = $(SPHINXDIR)/venv
PA11Y           = $(SPHINXDIR)/node_modules/pa11y/bin/pa11y.js --config $(SPHINXDIR)/pa11y.json
VENV            = $(VENVDIR)/bin/activate
TARGET          = *
ALLFILES        =  *.rst **/*.rst
METRICSDIR      = $(SOURCEDIR)/.sphinx/metrics
REQPDFPACKS     = latexmk fonts-freefont-otf texlive-latex-recommended texlive-latex-extra texlive-fonts-recommended texlive-font-utils texlive-lang-cjk texlive-xetex plantuml xindy tex-gyre dvipng
CONFIRM_SUDO    ?= N
VALE_CONFIG     = $(SPHINXDIR)/vale.ini
SPHINX_HOST     ?= 127.0.0.1
SPHINX_PORT     ?= 8000
PROJECT_ROOT    ?= $(shell readlink -f ../../)

export MIR_BUILD_API_DOCS
# Put it first so that "make" without argument is like "make help".
help:
	@echo
	@echo "-------------------------------------------------------------"
	@echo "* watch, build and serve the documentation:  make run"
	@echo "* only build:                                make html"
	@echo "* only serve:                                make serve"
	@echo "* clean built doc files:                     make clean-doc"
	@echo "* clean full environment:                    make clean"
	@echo "* check links:                               make linkcheck"
	@echo "* check markdown:                            make lint-md"
	@echo "* check spelling:                            make spelling"
	@echo "* check spelling (without building again):   make spellcheck"
	@echo "* check inclusive language:                  make woke"
	@echo "* check accessibility:                       make pa11y"
	@echo "* check style guide compliance:              make vale"
	@echo "* check style guide compliance on target:    make vale TARGET=*"
	@echo "* check metrics for documentation:           make allmetrics"
	@echo "* other possible targets:                    make <TAB twice>"
	@echo "-------------------------------------------------------------"
	@echo

.PHONY: help full‑help html epub pdf linkcheck spelling spellcheck woke \
        vale pa11y run serve install pa11y‑install   \
        vale‑install pdf‑prep pdf‑prep‑force clean clean‑doc allmetrics \
        update lint-md

full-help: $(VENVDIR)
	@. $(VENV); $(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	@echo "\n\033[1;31mNOTE: This help texts shows unsupported targets!\033[0m"
	@echo "Run 'make help' to see supported targets."

# If requirements are updated, venv should be rebuilt and timestamped.
$(VENVDIR):
	@echo "... setting up virtualenv"
	python3 -m venv $(VENVDIR) || { echo "You must install python3-venv before you can build the documentation."; exit 1; }
	. $(VENV); pip install $(PIPOPTS) --require-virtualenv \
	    --upgrade -r requirements.txt \
            --log $(VENVDIR)/pip_install.log
	@test ! -f $(VENVDIR)/pip_list.txt || \
            mv $(VENVDIR)/pip_list.txt $(VENVDIR)/pip_list.txt.bak
	@. $(VENV); pip list --local --format=freeze > $(VENVDIR)/pip_list.txt
	@touch $(VENVDIR)

pa11y-install:
	@command -v $(PA11Y) >/dev/null || { \
			echo "Installing \"pa11y\" from npm..."; echo; \
			mkdir -p $(SPHINXDIR)/node_modules/ ; \
			npm install --prefix $(SPHINXDIR) pa11y; \
		}

pymarkdownlnt-install:
	@. $(VENV); test -d $(VENVDIR)/lib/python*/site-packages/pymarkdown || pip install pymarkdownlnt

install: $(VENVDIR)

run: install
	. $(VENV); $(VENVDIR)/bin/sphinx-autobuild -b dirhtml --host $(SPHINX_HOST) --port $(SPHINX_PORT) "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)

# Does not depend on $(BUILDDIR) to rebuild properly at every run.
html: install
	. $(VENV); $(SPHINXBUILD) -W --keep-going -b dirhtml "$(SOURCEDIR)" "$(BUILDDIR)" -w $(SPHINXDIR)/warnings.txt $(SPHINXOPTS)

epub: install
	. $(VENV); $(SPHINXBUILD) -b epub "$(SOURCEDIR)" "$(BUILDDIR)" -w $(SPHINXDIR)/warnings.txt $(SPHINXOPTS)

serve: html
	cd "$(BUILDDIR)"; python3 -m http.server --bind 127.0.0.1 8000

clean: clean-doc
	# https://github.com/canonical/sphinx-docs-starter-pack/issues/435
	@test ! -e "$(VENVDIR)" -o -d "$(VENVDIR)"
	rm -rf $(VENVDIR)
	rm -rf $(SPHINXDIR)/node_modules/
	rm -rf $(SPHINXDIR)/styles
	rm -rf $(VALE_CONFIG)

clean-doc:
	git clean -fx "$(BUILDDIR)"
	rm -rf $(DOCTREESDIR)

linkcheck: install
	. $(VENV) ; $(SPHINXBUILD) -b linkcheck "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) || { grep --color -F "[broken]" "$(BUILDDIR)/output.txt"; exit 1; }
	exit 0

linkcheck-with-dependencies: install
	sudo add-apt-repository --yes ppa:mir-team/dev
	sudo apt-get --yes build-dep $(PROJECT_ROOT)
	. $(VENV); cmake -DMIR_ENABLE_TESTS=NO -DMIR_PLATFORM=x11 "$(PROJECT_ROOT)" -B "$(PROJECT_ROOT)"
	@$(MAKE) linkcheck

pa11y: pa11y-install html
	find $(BUILDDIR) -name *.html -print0 | xargs -n 1 -0 $(PA11Y)

lint-md: pymarkdownlnt-install
	@. $(VENV); pymarkdownlnt --config $(SPHINXDIR)/.pymarkdown.json scan --recurse --exclude=./$(SPHINXDIR)/** $(SOURCEDIR)

vale-install: install
	@. $(VENV); test -d $(VENVDIR)/lib/python*/site-packages/vale || pip install rst2html vale
	@. $(VENV); test -f $(VALE_CONFIG) || python3 $(SPHINXDIR)/get_vale_conf.py
	@echo '.Name=="Canonical.400-Enforce-inclusive-terms"' > $(SPHINXDIR)/styles/woke.filter
	@echo '.Level=="error" and .Name!="Canonical.500-Repeated-words" and .Name!="Canonical.000-US-spellcheck"' > $(SPHINXDIR)/styles/error.filter
	@echo '.Name=="Canonical.000-US-spellcheck"' > $(SPHINXDIR)/styles/spelling.filter
	@. $(VENV); find $(VENVDIR)/lib/python*/site-packages/vale/vale_bin -size 195c -exec vale --version \;

woke: vale-install
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt
	@cat $(SOURCEDIR)/.custom_wordlist.txt >> $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt
	@echo "Running Vale acceptable term check against $(TARGET). To change target set TARGET= with make command"
	@. $(VENV); vale --config="$(VALE_CONFIG)" --filter='$(SPHINXDIR)/styles/woke.filter' --glob='*.{md,rst}' $(TARGET)
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt && rm $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt

vale: vale-install
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt
	@cat $(SOURCEDIR)/.custom_wordlist.txt >> $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt
	@echo "Running Vale against $(TARGET). To change target set TARGET= with make command"
	@. $(VENV); vale --config="$(VALE_CONFIG)" --filter='$(SPHINXDIR)/styles/error.filter' --glob='*.{md,rst}' $(TARGET)
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt && rm $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt

spelling: vale-install
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt
	@cat $(SOURCEDIR)/.custom_wordlist.txt >> $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt
	@echo "Running Vale against $(TARGET). To change target set TARGET= with make command"
	@. $(VENV); vale --config="$(VALE_CONFIG)" --filter='$(SPHINXDIR)/styles/spelling.filter' --glob='*.{md,rst}' $(TARGET)
	@cat $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt > $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept.txt && rm $(SPHINXDIR)/styles/config/vocabularies/Canonical/accept_backup.txt

spellcheck: spelling
	@echo "Please note that the \`make spellcheck\` command is being deprecated in favor of \`make spelling\`"

pdf-prep: install
	@for packageName in $(REQPDFPACKS); do (dpkg-query -W -f='$${Status}' $$packageName 2>/dev/null | \
        grep -c "ok installed" >/dev/null && echo "Package $$packageName is installed") && continue || \
        (echo; echo "PDF generation requires the installation of the following packages: $(REQPDFPACKS)" && \
        echo "" && echo "Run 'sudo make pdf-prep-force' to install these packages" && echo "" && echo \
        "Please be aware these packages will be installed to your system") && exit 1 ; done

pdf-prep-force:
	apt-get update
	apt-get upgrade -y
	apt-get install --no-install-recommends -y $(REQPDFPACKS) \

pdf: pdf-prep
	@. $(VENV); sphinx-build -M latexpdf "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)
	@rm ./$(BUILDDIR)/latex/front-page-light.pdf || true
	@rm ./$(BUILDDIR)/latex/normal-page-footer.pdf || true
	@find ./$(BUILDDIR)/latex -name "*.pdf" -exec mv -t ./$(BUILDDIR) {} +
	@rm -r $(BUILDDIR)/latex
	@echo
	@echo "Output can be found in ./$(BUILDDIR)"
	@echo

allmetrics: html
	@echo "Recording documentation metrics..."
	@echo "Checking for existence of vale..."
	. $(VENV)
	@. $(VENV); test -d $(VENVDIR)/lib/python*/site-packages/vale || pip install vale
	@. $(VENV); test -f $(VALE_CONFIG) || python3 $(SPHINXDIR)/get_vale_conf.py
	@. $(VENV); find $(VENVDIR)/lib/python*/site-packages/vale/vale_bin -size 195c -exec vale --config "$(VALE_CONFIG)" $(TARGET) > /dev/null \;
	@eval '$(METRICSDIR)/source_metrics.sh $(PWD)'
	@eval '$(METRICSDIR)/build_metrics.sh $(PWD) $(METRICSDIR)'

update: install
	@. $(VENV); .sphinx/update_sp.py

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%:
	$(MAKE) —no-print-directory install
	. $(VENV); $(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== doc/sphinx/requirements.txt ===
canonical-sphinx[full]
packaging
sphinxcontrib-svg2pdfconverter[CairoSVG]
sphinx-last-updated-by-git
sphinx-sitemap
breathe
exhale
pillow
sphinxcontrib-mermaid

=== examples/mir_demo_server/CMakeLists.txt ===
add_definitions(-DMIR_LOG_COMPONENT_FALLBACK="demo_server")

add_library(exampleserverconfig STATIC
  server_example_input_event_filter.cpp
  server_example_input_filter.cpp
)

target_link_libraries(exampleserverconfig
  mirserver
  mirwayland
)

include_directories(
  ${PROJECT_SOURCE_DIR}/src/include/server
)

mir_add_wrapped_executable(mir_demo_server
    server_example.cpp
    server_example_test_client.cpp
)

target_link_libraries(mir_demo_server
  example-shell-lib
  exampleserverconfig
)

=== examples/miral-kiosk/CMakeLists.txt ===
mir_add_wrapped_executable(miral-kiosk
    kiosk_main.cpp
    kiosk_window_manager.cpp    kiosk_window_manager.h
)

target_link_libraries(miral-kiosk example-shell-lib)

# I'm not sure why this is needed in a chroot, but it's not worth finding out
if(DEFINED MIR_CHROOT)
    target_link_libraries(miral-kiosk EGL PkgConfig::GLESv2)
endif()

=== examples/tests/CMakeLists.txt ===

mir_add_wrapped_executable(mir_examples_tests NOINSTALL
  test_floating_window_manager.cpp)

target_include_directories(mir_examples_tests
  PRIVATE
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/tests/include
  ${PROJECT_SOURCE_DIR}/include/test
  ${PROJECT_SOURCE_DIR}/src/include/common
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR})

target_link_libraries(mir_examples_tests
  mir-test-static
  mir-public-test-framework
  mir-test-framework-static
  mir-test-doubles-static
  mircommon
  miral
  example-shell-lib
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES})

CMAKE_DEPENDENT_OPTION(
  MIR_RUN_EXAMPLES_TESTS
  "Run tests on examples as part of default testing"
  ON
  "MIR_RUN_EXAMPLES_TESTS"
  OFF)

if (MIR_RUN_EXAMPLES_TESTS)
  mir_discover_tests_with_fd_leak_detection(mir_examples_tests)
endif (MIR_RUN_EXAMPLES_TESTS)

=== src/common/CMakeLists.txt ===
add_compile_definitions(MIR_LOG_COMPONENT_FALLBACK="mircommon")

set(MIR_COMMON_SOURCES)

add_subdirectory(events)
add_subdirectory(logging)
add_subdirectory(report/lttng)
add_subdirectory(sharedlibrary)
add_subdirectory(thread)
add_subdirectory(time)
add_subdirectory(dispatch)

list(APPEND MIR_COMMON_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/output_type_names.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/libname.cpp
  ${PROJECT_SOURCE_DIR}/include/common/mir/libname.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/posix_rw_mutex.h
  posix_rw_mutex.cpp
  default_font.cpp
  event.cpp
  event_printer.cpp
  mir_cursor_api.cpp
  thread_pool_executor.cpp
  linearising_executor.cpp
  immediate_executor.cpp
  ${PROJECT_SOURCE_DIR}/include/common/mir/signal.h
  signal.cpp
)


# TODO we need a place to manage ABI and related versioning but use this as placeholder
set(MIRCOMMON_ABI 11)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

add_library(mircommon SHARED
  input/mir_input_config.cpp
  input/mir_touchpad_config.cpp
  input/mir_pointer_config.cpp
  input/mir_keyboard_config.cpp
  input/mir_touchscreen_config.cpp
  input/input_event.cpp
  input/xkb_mapper.cpp
  input/parameter_keymap.cpp
  input/buffer_keymap.cpp
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_input_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_pointer_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_touchpad_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_touchscreen_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/mir_keyboard_config.h
  ${PROJECT_SOURCE_DIR}/include/common/mir/input/keyboard_leds.h
  ${MIR_COMMON_SOURCES}
)

target_include_directories(mircommon
  PUBLIC
    ${PROJECT_SOURCE_DIR}/include/common
  PRIVATE
    ${PROJECT_SOURCE_DIR}/src/include/common
)

target_link_libraries(mircommon
  PUBLIC
    mirsharedlogging
    mirsharedlttng
    mirsharedsharedlibrary
    mirsharedthread
    mirevents
    mirtime
)


set_target_properties(mircommon

  PROPERTIES
  SOVERSION ${MIRCOMMON_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
)

install(TARGETS mircommon LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/common/mir
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mircommon"
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/src/include/common/mir
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mircommon-internal"
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/common/mir_toolkit
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mircommon"
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mircommon.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mircommon.pc
  @ONLY
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/mircommon-internal.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mircommon-internal.pc
  @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mircommon.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mircommon-internal.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

add_custom_target(
    generate-mircommon-symbols-map
    COMMAND ${PROJECT_SOURCE_DIR}/tools/symbols_map_generator/main.py
        --library-name mir_common
        --version ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        --symbols-map-path="${CMAKE_CURRENT_SOURCE_DIR}/symbols.map"
        --include-dirs="$<JOIN:$<TARGET_PROPERTY:mircommon,INTERFACE_INCLUDE_DIRECTORIES>,:>"
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}")

add_custom_target(
    check-mircommon-symbols-map
    COMMAND ${PROJECT_SOURCE_DIR}/tools/symbols_map_generator/main.py
        --library-name mir_common
        --version ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        --symbols-map-path="${CMAKE_CURRENT_SOURCE_DIR}/symbols.map"
        --include-dirs="$<JOIN:$<TARGET_PROPERTY:mircommon,INTERFACE_INCLUDE_DIRECTORIES>,:>"
        --diff
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}")

=== src/core/CMakeLists.txt ===
set(MIRCORE_ABI 2)

# We don't need libmircore to have an unused dependency on libpthread
string (REPLACE " -pthread " " " CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})

add_library(mircore SHARED
    anonymous_shm_file.cpp
    fatal.cpp
    fd.cpp
    depth_layer.cpp
    geometry/rectangles.cpp
    input/mousekeys_keymap.cpp
    report_exception.cpp ${PROJECT_SOURCE_DIR}/include/core/mir/report_exception.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/anonymous_shm_file.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/int_wrapper.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/optional_value.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/fatal.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/fd.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/rectangle.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/point.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/rectangles.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/displacement.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/size.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/forward.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/geometry/dimensions.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/shm_file.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/depth_layer.h
    ${PROJECT_SOURCE_DIR}/include/core/mir_toolkit/common.h
    ${PROJECT_SOURCE_DIR}/include/core/mir_toolkit/mir_version_number.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/synchronised.h
    ${PROJECT_SOURCE_DIR}/include/core/mir/input/mousekeys_keymap.h
)

target_include_directories(mircore
  PUBLIC
    ${PROJECT_SOURCE_DIR}/include/core
)


set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

set_target_properties(mircore
    PROPERTIES
    SOVERSION ${MIRCORE_ABI}
    LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
    LINK_DEPENDS ${symbol_map}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/mircore.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/mircore.pc
    @ONLY
)

install(TARGETS mircore LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/include/core/mir ${CMAKE_SOURCE_DIR}/include/core/mir_toolkit
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mircore"
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/mircore.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/miral/CMakeLists.txt ===
include_directories(
  ${PROJECT_SOURCE_DIR}/src/include/server
)

set(MIRAL_ABI 7)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)
set(miral_include ${PROJECT_SOURCE_DIR}/include/miral)

pkg_check_modules(YAML REQUIRED IMPORTED_TARGET yaml-cpp)
pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-2.0 gio-unix-2.0)

add_compile_definitions(MIR_LOG_COMPONENT_FALLBACK="miral" MIRAL_ENABLE_DEPRECATIONS=0)

add_library(miral-internal STATIC
    active_outputs.cpp                   active_outputs.h
    application_info_internal.cpp        application_info_internal.h
    application_selector.cpp             application_selector.h
    basic_window_manager.cpp             basic_window_manager.h window_manager_tools_implementation.h
    system_compositor_window_manager.cpp system_compositor_window_manager.h
    display_configuration_listeners.cpp  display_configuration_listeners.h
    fd_manager.cpp                       fd_manager.h
    input_device_config.cpp              input_device_configuration_options.h input_device_config.h
    launch_app.cpp                       launch_app.h
    render_scene_into_surface.cpp        render_scene_into_surface.h
    mru_window_list.cpp                  mru_window_list.h
    open_desktop_entry.cpp               open_desktop_entry.h
    static_display_config.cpp            static_display_config.h
    wayland_app.cpp                      wayland_app.h
    layer_shell_wayland_surface.cpp      layer_shell_wayland_surface.h
    wayland_shm.cpp                      wayland_shm.h
    window_info_internal.cpp             window_info_internal.h
    window_management_trace.cpp          window_management_trace.h
    xcursor_loader.cpp                   xcursor_loader.h
    xcursor.c                            xcursor.h
                                         join_client_threads.h
                                         window_info_defaults.h
    window_specification_internal.cpp    window_specification_internal.h
)

# Already implied by the linker's symbol version script, but can avoid accidents
set_target_properties(miral-internal
    PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS}  -fvisibility=hidden")

set_source_files_properties(xcursor.c PROPERTIES COMPILE_DEFINITIONS _GNU_SOURCE)

check_cxx_compiler_flag(-Wstringop-truncation HAS_W_STRINGOP_TRUNCATION)
if (HAS_W_STRINGOP_TRUNCATION)
    set_source_files_properties(xcursor.c PROPERTIES
        COMPILE_FLAGS "-Wno-error=stringop-truncation"
    )
endif()

set(PROTOCOLS_DIR ${CMAKE_SOURCE_DIR}/wayland-protocols)
set(GENERATED_DIR ${CMAKE_BINARY_DIR}/miral-generated)

function(add_wayland_protocol xml_file out_var)
    get_filename_component(name ${xml_file} NAME_WE)
    set(header ${GENERATED_DIR}/${name}.h)
    set(code   ${GENERATED_DIR}/${name}.c)

    add_custom_command(
      OUTPUT ${header}
      COMMAND ${CMAKE_COMMAND} -E make_directory ${GENERATED_DIR}
      COMMAND wayland-scanner client-header "${xml_file}" "${header}.tmp"
      COMMAND sed -i s/\\<namespace\\>/namespace_/g "${header}.tmp"
      COMMAND ${CMAKE_COMMAND} -E rename ${header}.tmp ${header}
      DEPENDS ${xml_file}
      VERBATIM
    )

    add_custom_command(
      OUTPUT ${code}
      COMMAND ${CMAKE_COMMAND} -E make_directory ${GENERATED_DIR}
      COMMAND wayland-scanner private-code "${xml_file}" "${code}.tmp"
      COMMAND sed -i s/\\<namespace\\>/namespace_/g "${code}.tmp"
      COMMAND ${CMAKE_COMMAND} -E rename ${code}.tmp ${code}
      DEPENDS ${xml_file}
      VERBATIM
    )

    set(${out_var} ${${out_var}} ${header} ${code} PARENT_SCOPE)
endfunction()

set(PROTOCOL_XMLS
  ${PROTOCOLS_DIR}/wlr-foreign-toplevel-management-unstable-v1.xml
  ${PROTOCOLS_DIR}/wlr-layer-shell-unstable-v1.xml
  ${PROTOCOLS_DIR}/wlr-layer-shell-unstable-v1.xml
  ${PROTOCOLS_DIR}/xdg-shell.xml
)

set(GENERATED_PROTOCOL_SOURCES "")
foreach(xml ${PROTOCOL_XMLS})
    add_wayland_protocol(${xml} GENERATED_PROTOCOL_SOURCES)
endforeach()

add_library(protocols STATIC ${GENERATED_PROTOCOL_SOURCES})

target_include_directories(protocols PUBLIC ${GENERATED_DIR})
target_link_libraries(protocols PUBLIC PkgConfig::WAYLAND_CLIENT)

add_library(miral-external OBJECT
    add_init_callback.cpp               ${miral_include}/miral/add_init_callback.h
    application.cpp                     ${miral_include}/miral/application.h
    add_init_callback.cpp               ${miral_include}/miral/add_init_callback.h
    application_switcher.cpp            ${miral_include}/miral/application_switcher.h
    application.cpp                     ${miral_include}/miral/application.h
    application_authorizer.cpp          ${miral_include}/miral/application_authorizer.h
    application_info.cpp                ${miral_include}/miral/application_info.h
    canonical_window_manager.cpp        ${miral_include}/miral/canonical_window_manager.h
    config_file.cpp                     ${miral_include}/miral/config_file.h
    configuration_option.cpp            ${miral_include}/miral/configuration_option.h
    ${miral_include}/miral/command_line_option.h
    cursor_theme.cpp                    ${miral_include}/miral/cursor_theme.h
    custom_renderer.cpp                 ${miral_include}/miral/custom_renderer.h
    display_configuration.cpp           ${miral_include}/miral/display_configuration.h
    external_client.cpp                 ${miral_include}/miral/external_client.h
    idle_listener.cpp                   ${miral_include}/miral/idle_listener.h
    input_configuration.cpp             ${miral_include}/miral/input_configuration.h
    keymap.cpp                          ${miral_include}/miral/keymap.h
    minimal_window_manager.cpp          ${miral_include}/miral/minimal_window_manager.h
    floating_window_manager.cpp         ${miral_include}/miral/floating_window_manager.h
    display_configuration_option.cpp    ${miral_include}/miral/display_configuration_option.h
    output.cpp                          ${miral_include}/miral/output.h
    append_event_filter.cpp             ${miral_include}/miral/append_event_filter.h
    append_keyboard_event_filter.cpp    ${miral_include}/miral/append_keyboard_event_filter.h
    wayland_extensions.cpp              ${miral_include}/miral/wayland_extensions.h
    wayland_tools.cpp                   ${miral_include}/miral/wayland_tools.h
    window.cpp                          ${miral_include}/miral/window.h
    window_info.cpp                     ${miral_include}/miral/window_info.h
    window_management_options.cpp       ${miral_include}/miral/window_management_options.h
    window_specification.cpp            ${miral_include}/miral/window_specification.h
    internal_client.cpp                 ${miral_include}/miral/internal_client.h
    prepend_event_filter.cpp            ${miral_include}/miral/prepend_event_filter.h
    runner.cpp                          ${miral_include}/miral/runner.h
    session_lock_listener.cpp           ${miral_include}/miral/session_lock_listener.h
    set_command_line_handler.cpp        ${miral_include}/miral/set_command_line_handler.h
    set_terminator.cpp                  ${miral_include}/miral/set_terminator.h
    set_window_management_policy.cpp    ${miral_include}/miral/set_window_management_policy.h
    toolkit_event.cpp                   ${miral_include}/miral/toolkit_event.h
    window_management_policy.cpp        ${miral_include}/miral/window_management_policy.h
    window_manager_tools.cpp            ${miral_include}/miral/window_manager_tools.h
    ${miral_include}/miral/lambda_as_function.h
    x11_support.cpp                     ${miral_include}/miral/x11_support.h
    zone.cpp                            ${miral_include}/miral/zone.h
    decorations.cpp                     ${miral_include}/miral/decorations.h
    cursor_scale.cpp                    ${miral_include}/miral/cursor_scale.h
    mousekeys_config.cpp                ${miral_include}/miral/mousekeys_config.h
    output_filter.cpp                   ${miral_include}/miral/output_filter.h
    simulated_secondary_click.cpp       ${miral_include}/miral/simulated_secondary_click.h
    live_config.cpp                     ${miral_include}/miral/live_config.h
    live_config_ini_file.cpp            ${miral_include}/miral/live_config_ini_file.h
    hover_click.cpp                     ${miral_include}/miral/hover_click.h
    magnifier.cpp                       ${miral_include}/miral/magnifier.h
    bounce_keys.cpp                     ${miral_include}/miral/bounce_keys.h
    slow_keys.cpp                       ${miral_include}/miral/slow_keys.h
    sticky_keys.cpp                     ${miral_include}/miral/sticky_keys.h
    locate_pointer.cpp                  ${miral_include}/miral/locate_pointer.h
)

add_library(miral SHARED
    ${miral_include}/miral/runner.h # Syntactically, we need something here
)

check_cxx_compiler_flag(-Wno-attribute-alias HAS_W_NO_ATTRIBUTE_ALIAS)
if(HAS_W_NO_ATTRIBUTE_ALIAS)
    set_source_files_properties(
            canonical_window_manager.cpp
            internal_client.cpp
            set_window_management_policy.cpp
            window_info.cpp
            window_management_policy.cpp
            window_manager_tools.cpp
            PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS} -Wno-attribute-alias")
endif()

target_include_directories(miral-internal
    PRIVATE "${miral_include}"
)

target_link_libraries(miral-internal
    PRIVATE
        mirserver
        PkgConfig::WAYLAND_CLIENT
        PkgConfig::YAML
        PkgConfig::GIO
        protocols
)

target_include_directories(miral-external
    PUBLIC  "${miral_include}"
)

target_include_directories(miral
    PUBLIC  "${miral_include}"
)

target_link_libraries(miral-external
    PUBLIC
        mircore
    PRIVATE
        miral-internal
        mirserver
        protocols
        PkgConfig::FREETYPE
)

target_link_libraries(miral
    PUBLIC
        miral-external
        PkgConfig::XKBCOMMON
    PRIVATE
        miral-internal
)

set_target_properties(miral
        PROPERTIES
        SOVERSION ${MIRAL_ABI}
        LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
        LINK_DEPENDS ${symbol_map}
)

find_program(MIR_DPKG_GENSYMBOLS dpkg-gensymbols)
if (CMAKE_COMPILER_IS_GNUCXX   AND  # clang generates slightly different symbols (but we don't care)
    MIR_USE_LD EQUAL "ld"      AND  # lld on 22.04 generates slightly different symbols (but we don't care)
    MIR_DPKG_GENSYMBOLS)

    set(MIR_CHECK_MIRAL_SYMBOLS_DEFAULT ALL)
endif()

add_custom_target(regenerate-miral-debian-symbols ${MIR_CHECK_MIRAL_SYMBOLS_DEFAULT}
    DEPENDS miral ${PROJECT_SOURCE_DIR}/debian/libmiral${MIRAL_ABI}.symbols
    COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/check-and-update-debian-symbols.py ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} miral ${MIRAL_VERSION} ${MIRAL_ABI}
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    VERBATIM)

add_custom_target(
        generate-miral-symbols-map
        COMMAND ${PROJECT_SOURCE_DIR}/tools/symbols_map_generator/main.py
            --library-name miral
            --version ${MIRAL_VERSION}
            --symbols-map-path="${CMAKE_CURRENT_SOURCE_DIR}/symbols.map"
            --include-dirs "$<JOIN:$<TARGET_PROPERTY:miral,INTERFACE_INCLUDE_DIRECTORIES>,:>"
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}")

add_custom_target(
        check-miral-symbols-map
        COMMAND ${PROJECT_SOURCE_DIR}/tools/symbols_map_generator/main.py
        --library-name miral
        --version ${MIRAL_VERSION}
        --symbols-map-path="${CMAKE_CURRENT_SOURCE_DIR}/symbols.map"
        --external-headers-directory="${PROJECT_SOURCE_DIR}/include/miral"
        --include-dirs "$<JOIN:$<TARGET_PROPERTY:miral,INTERFACE_INCLUDE_DIRECTORIES>,:>"
        --diff
        WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/miral.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/miral.pc
    @ONLY
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${miral_include}/miral/version.h
)

=== debian/changelog ===
mir (2.25.2-1) experimental; urgency=medium

  * New upstream release.
  * debian/:
    + SOVERSION major bump.
  * debian/patches/:
    + Rebase patches 1003, 2003 and 2005.
    + Add 1005_typo-fixes.patch. Fix typo in TEST names.
    + Drop 1004_fix-autopkgtest.patch. Applied upstream.
    + Forward upstream: 1003_cross.patch and 1005_typo-fixes.patch.
  * debian/control:
    + Apply wrap-and-sort -t -n -a.
    + Drop Pre-Depends: fields.
    + Drop Priority: optional.
    + Update B-Ds for v2.25.2.
    + Bump Standards-Version: to 4.7.3.
    + Adjust dev:pkgs to new version.
    + Drop libboost-system-dev. (Closes: #1127238).
  * debian/rules:
    + Adopt from upstream's DEB packaging Git.
    + Fix setting of XDG_RUNTIME_DIR in ptest environment.
    + Fail build on test failure.
    + Set DPKG_EXPORT_BUILDFLAGS to 1.
  * debian/*.install:
    + Adjust (and wrap-and-sort) to new version.
  * debian/{control,rules}:
    + Drop pkg-kde-tools. Stop maintaining .symbols files with pkgkde-symbols-
      helper.
  * debian/source/lintian-overrides:
    + Fix line number in file.
    + Drop reference to file not in upstream source tree anymore.
  * debian/tests/control:
    + Apply wrap-and-sort.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
    + Update attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 28 Feb 2026 23:49:27 +0100

=== debian/control ===
Source: mir
Section: x11
Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
Uploaders: Simon Quigley <tsimonq2@debian.org>,
           Christopher James Halse Rogers <raof@ubuntu.com>,
           Mike Gabriel <sunweaver@debian.org>,
           Debian UBports Team <team+ubports@tracker.debian.org>,
           Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               dbus,
               debhelper-compat (= 13),
               doxygen,
               dpkg-dev (>= 1.22.5),
               eglexternalplatform-dev [amd64 i386],
               google-mock (>= 1.6.0+svn437) <!noinsttest>,
               graphviz,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libclang-dev,
               libdisplay-info-dev,
               libdrm-dev,
               libegl-dev,
               libepoxy-dev,
               libevdev-dev,
               libfreetype-dev,
               libgbm-dev,
               libgles-dev,
               libglib2.0-dev,
               libglm-dev,
               libgoogle-glog-dev,
               libgtest-dev <!noinsttest>,
               libinput-dev (>= 0.21),
               liblttng-ust-dev,
               libmirwayland-bin <cross>,
               libnvidia-egl-wayland-dev [amd64 i386],
               libpixman-1-dev,
               libudev-dev,
               libumockdev-dev (>= 0.6) <!noinsttest>,
               libwayland-dev,
               libx11-xcb-dev,
               libxcb-composite0-dev,
               libxcb-randr0-dev,
               libxcb-render0-dev,
               libxcb-res0-dev,
               libxcb-xfixes0-dev,
               libxcursor-dev,
               libxkbcommon-dev (>= 0.5),
               libxkbcommon-x11-dev,
               libxml++2.6-dev,
               libyaml-cpp-dev,
               linux-libc-dev,
               nettle-dev,
               pkgconf,
               python3-dbusmock <!noinsttest>,
               python3-pil:native,
               rdfind,
               symlinks,
               systemtap-sdt-dev,
               umockdev (>= 0.8.7) <!noinsttest>,
               uuid-dev,
# only enable valgrind once it's been tested to work on each architecture:
               valgrind-if-available <!noinsttest>,
               wlcs (>= 1.6.0) <!noinsttest>,
               xsltproc,
               xwayland,
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: https://mir-server.io/
Vcs-Browser: https://salsa.debian.org/mir-server-team/mir
Vcs-Git: https://salsa.debian.org/mir-server-team/mir.git

#TODO: Packaging infrastructure for better dependency generation,
#      ala pkg-xorg's xviddriver:Provides and ABI detection.
Package: libmirserver66
Replaces: libmirserver58,
          libmirserver58t64,
          libmirserver62,
          libmirserver63,
Breaks: libmirserver58 (<< ${source:Version}),
        libmirserver58t64 (<< ${source:Version}),
        libmirserver62 (<< ${source:Version}),
        libmirserver63 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - server library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared library needed by server applications for Mir.

Package: libmirplatform34
Replaces: libmirplatform26,
          libmirplatform26t64,
          libmirplatform30,
Breaks: libmirplatform26 (<< ${source:Version}),
        libmirplatform26t64 (<< ${source:Version}),
        libmirplatform30 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - platform library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the shared libraries required for the Mir server to interact with
 the underlying hardware platform.

Package: libmircore-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircore2t64 (= ${binary:Version}),
         ${misc:Depends},
Description: Mir Display Server - core library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains core header files required for server and/or client development.

Package: libmircommon-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon11 (= ${binary:Version}),
         libmircore-dev (= ${binary:Version}),
         libxkbcommon-dev,
         ${misc:Depends},
Breaks: mircommon-dev (<< 0.6),
Replaces: mircommon-dev (<< 0.6),
Description: Mir Display Server - common library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains common header files required for server and/or client development.

Package: libmircommon-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon-dev (= ${binary:Version}),
         libxkbcommon-dev,
         ${misc:Depends},
Description: Mir Display Server - internal common development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package contains common internal headers with no stability
 guarantee, for servers that wish to use functionality for which no
 public API exists yet.

Package: libmirplatform-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libboost-program-options-dev,
         libgbm-dev,
         libmircommon-dev (= ${binary:Version}),
         libmirplatform34 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libmirplatform (<< 0.6),
        libmirrenderer-dev (<< 2.24),
        mir-renderer-gl-dev (<< 2.24),
Replaces: libmirplatform (<< 0.6),
          libmirrenderer-dev (<< 2.24),
          mir-renderer-gl-dev (<< 2.24),
Provides: libmirrenderer-dev,
          mir-renderer-gl-dev,
Description: Mir Display Server - platform library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required for hardware/driver support development.

Package: libmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libglm-dev,
         libmircommon-dev (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmirserver66 (= ${binary:Version}),
         uuid-dev,
         ${misc:Depends},
Description: Mir Display Server - server library - development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files required to build Mir servers.

Package: libmirserver-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libglm-dev,
      libmirserver66 (= ${binary:Version}),
      libmirplatform-dev (= ${binary:Version}),
      libmircommon-dev (= ${binary:Version}),
      libmircore-dev (= ${binary:Version}),
      libmirserver-dev (= ${binary:Version}),
      uuid-dev,
      ${misc:Depends},
Description: Mir Display Server - internal server development headers
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 This package contains internal server headers with no stability
 guarantee, for servers that wish to use functionality for which no
 public API exists yet.

Package: mirtest-dev
Build-Profiles: <!noinsttest>
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libmircommon-dev (= ${binary:Version}),
         libmirplatform-dev (= ${binary:Version}),
         libmirserver-dev (= ${binary:Version}),
         mir-platform-graphics-stub23,
         mir-platform-input-stub10,
         ${misc:Depends},
Description: Mir Display Server - test development headers and library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains header files and static library for testing of server and/or client
 development.

Package: mirtest-internal-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: mirtest-dev,
         libmirserver-dev (= ${binary:Version}),
         ${misc:Depends},
Breaks: mirtest-dev (<< 2.25.2-1~),
Replaces: mirtest-dev (<< 2.25.2-1~),
Description: Mir Display Server - internal test development headers and library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains internal header files and static library for testing of server
 and/or client development.

Package: mir-demos
Architecture: linux-any
Breaks: miral-examples,
Replaces: miral-examples,
Provides: miral-examples (=1.5),
Depends: inotify-tools,
         python3:any,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: dmz-cursor-theme,
            fonts-liberation,
            qtwayland5,
            xwayland,
Description: Mir Display Server - demonstration programs
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains demo applications that use the Mir display server

Package: mir-test-tools
Build-Profiles: <!noinsttest>
Architecture: linux-any
Depends: dmz-cursor-theme,
         glmark2-es2,
         glmark2-es2-wayland,
         mesa-utils-extra,
         xwayland,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - stress tests and other test tools
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains tools for smoke and performance testing the Mir display server

Package: mir-wlcs-integration
Architecture: linux-any
Build-Profiles: <!noinsttest>
Breaks: mir-test-tools (<< 2.0.0.0+dev148~),
Replaces: mir-test-tools (<< 2.0.0.0+dev148~),
Depends: ${misc:Depends},
         ${shlibs:Depends},
         mir-platform-graphics-stub23,
         mir-platform-input-stub10,
Description: Mir Display Server - wlcs integration
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains libraries for integration with the wlcs test suite

Package: libmircore2t64
Provides: ${t64:Provides},
Replaces: libmircore2,
Breaks: libmircore2 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - core library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'core' shared library required for the Mir server and client.

Package: libmircommon11
Replaces: libmircommon9,
          libmircommon9t64,
Breaks: libmircommon9 (<< ${source:Version}),
        libmircommon9t64 (<< ${source:Version}),
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Mir Display Server - common library
 Mir is a display server running on Linux systems, with a focus on efficiency,
 robust operation and a well-defined driver model.
 .
 Contains the 'common' shared library required for the Mir server and client.

# Longer-term these drivers should move out-of-tree
Package: mir-platform-graphics-x23
Section: libs
Architecture: linux-any
Multi-Arch: same
Replaces: mir-platform-graphics-x20,
          mir-platform-graphics-x22,

=== debian/rules ===
#!/usr/bin/make -f

BUILD_HOME=$(CURDIR)/debian/home
BUILD_XDG_RUNTIME_DIR=$(CURDIR)/debian/run

include /usr/share/dpkg/default.mk
include debian/opts.mk

# Needed for ccache to work in case the build directory changed
# (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=810871)
export CCACHE_BASEDIR = $(shell pwd)

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ -Bbuild-$(DEB_HOST_ARCH)

# Enable verbose debugging output from the testsuite
export MIR_SERVER_LOGGING = on
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(filter mipsel riscv64,$(DEB_HOST_ARCH)),)
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	mkdir -p $(BUILD_HOME)
	mkdir -p $(BUILD_XDG_RUNTIME_DIR)
	dh_auto_build -- HOME="$(BUILD_HOME)" XDG_RUNTIME_DIR="$(BUILD_XDG_RUNTIME_DIR)" GTEST_OUTPUT=xml:./ ARGS="-V" ptest
else
	echo "Testsuite disabled on $(DEB_HOST_ARCH) due to lack of big-endian support."
endif
else
	echo "Testsuite disabled on $(DEB_HOST_ARCH) due to timeouts / slow CPU processing."
endif
else
	echo "Testsuite disabled due to DEB_BUILD_OPTIONS=\"$(DEB_BUILD_OPTIONS)\""
endif

override_dh_auto_test-indep:
	echo "Testsuite not run during arch:all builds."

COMMON_CONFIGURE_OPTIONS = \
  -DCMAKE_INSTALL_LIBEXECDIR="lib/$(DEB_HOST_MULTIARCH)/mir" \
  -DMIR_BUILD_INTERPROCESS_TESTS=OFF \
  -DMIR_ENABLE_RUST=OFF \
  -DMIR_FATAL_COMPILE_WARNINGS=OFF

# Disable LTO on broken binutils
# https://bugs.launchpad.net/ubuntu/+source/binutils/+bug/2070302
ifeq ($(filter arm64,$(DEB_HOST_ARCH)),arm64)
	ifneq ($(shell ld --version | grep -E '(2.43.1|2.44|2.44.50.20250707)$$'),)
		DEB_BUILD_MAINT_OPTIONS += optimize=-lto
	endif
endif

# Disable tests on Launchpad riscv64 (canonical/mir#3443, canonical/mir#3470)
ifeq ($(USER) $(DEB_HOST_ARCH),buildd riscv64)
	COMMON_CONFIGURE_OPTIONS += -DMIR_RUN_MIRAL_TESTS=OFF
	COMMON_CONFIGURE_OPTIONS += -DMIR_RUN_WINDOW_MANAGEMENT_TESTS=OFF
	COMMON_CONFIGURE_OPTIONS += -DMIR_RUN_WLCS_TESTS=OFF
endif

# Disable pre-compiled headers on GCC>=12
ifneq ($(shell gcc --version | grep '1[234].[[:digit:]]\+.[[:digit:]]\+$$'),)
	COMMON_CONFIGURE_OPTIONS += -DMIR_USE_PRECOMPILED_HEADERS=OFF
endif

export DEB_BUILD_MAINT_OPTIONS

$(info COMMON_CONFIGURE_OPTIONS: ${COMMON_CONFIGURE_OPTIONS})
$(info DEB_BUILD_MAINT_OPTIONS: ${DEB_BUILD_MAINT_OPTIONS})

ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH)),)
       AVAILABLE_PLATFORMS=atomic-kms\;gbm-kms\;x11\;wayland\;eglstream-kms
else
       AVAILABLE_PLATFORMS=atomic-kms\;gbm-kms\;x11\;wayland
endif


override_dh_auto_configure:
ifneq ($(filter armhf,$(DEB_HOST_ARCH)),)
	dh_auto_configure -- \
	  $(COMMON_CONFIGURE_OPTIONS) \
	  -DMIR_RUN_ACCEPTANCE_TESTS=OFF \
	  -DMIR_RUN_INTEGRATION_TESTS=OFF \
	  -DMIR_PLATFORM=$(AVAILABLE_PLATFORMS) \
	  $(OVERRIDE_CONFIGURE_OPTIONS)
else
ifneq ($(filter arm64,$(DEB_HOST_ARCH)),)
	dh_auto_configure -- \
	  $(COMMON_CONFIGURE_OPTIONS) \
	  -DMIR_RUN_ACCEPTANCE_TESTS=OFF \
	  -DMIR_PLATFORM=$(AVAILABLE_PLATFORMS) \
	  $(OVERRIDE_CONFIGURE_OPTIONS)
else
	dh_auto_configure -- \
	  $(COMMON_CONFIGURE_OPTIONS) \
	  -DMIR_PLATFORM=$(AVAILABLE_PLATFORMS) \
	  $(OVERRIDE_CONFIGURE_OPTIONS)
endif
endif
	# Run cmake again to pick up wlcs tests, because reasons?
	cmake build-$(DEB_HOST_ARCH)

# Reconstruct the MirAL version
MIRAL_VERSION_MAJOR = $(shell perl -n -e '/^set\(MIRAL_VERSION_MAJOR ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_VERSION_MINOR = $(shell perl -n -e '/^set\(MIRAL_VERSION_MINOR ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_VERSION_PATCH = $(shell perl -n -e '/^set\(MIRAL_VERSION_PATCH ([0-9]*)\)$$/ && print $$1' src/CMakeLists.txt)
MIRAL_RELEASE=$(MIRAL_VERSION_MAJOR).$(MIRAL_VERSION_MINOR).$(MIRAL_VERSION_PATCH)
MIRAL_VERSION=$(MIRAL_RELEASE).$(DEB_VERSION)

# TODO: we'll use a symbol file once mir is abi stable
override_dh_makeshlibs:
	dh_makeshlibs -Nlibmiral7 -V -Nmir-test-tools
	dh_makeshlibs -plibmiral7 -V -- -v$(MIRAL_RELEASE)

# Don't try to strip libraries used as test data
override_dh_strip:
	dh_strip -Xmir-test-data

# Don't try to find dependencies of libraries used as test data
override_dh_shlibdeps:
	dh_shlibdeps -Xmir-test-data

override_dh_gencontrol:
	dh_gencontrol -Nlibmiral7 -Nlibmiral-dev
	dh_gencontrol -plibmiral7 -plibmiral-dev -- -v$(MIRAL_VERSION) -V'libmiral7:Version=$(MIRAL_VERSION)'

override_dh_auto_clean:
	dh_auto_clean
	# build cruft not cleaned up by CMake
	rm -f include/miral/miral/version.h include/server/mir/version.h

override_dh_clean:
	dh_clean
	rm -Rfv $(BUILD_HOME)
	rm -Rfv $(BUILD_XDG_RUNTIME_DIR)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/tests/control ===
Tests: wlcs,
Restrictions: allow-stderr,
              skippable,
Depends: build-essential,
         cmake,
         dpkg,
         mir-wlcs-integration,
         pkg-config,
         wlcs,
